(define-module (ui openvpn-server ajax)
			   :use-module (alterator ajax)
			   :use-module (alterator woo)
			   :export (init))

(define (update-interface)
  (let ((routed (string=? (form-value "type") "routed")))
	(form-update-visibility "vpnnet" routed)
	(form-update-visibility "server_net" routed)
	(form-update-visibility "server_netmask" routed)
	(form-update-visibility "server_vpnaddr" (not routed))
	(form-update-visibility "vpnpool_start" (not routed))
	(form-update-visibility "vpnpool_end" (not routed))
	(form-update-activity "clients_managment" routed)))


(define (read-config)
  (let ((cmd (woo-read-first "/openvpn-server" 'type (form-value "type" 'language (form-value "language")))))
	(form-update-enum "type" (woo-list "/openvpn-server/avail_types"))
	(form-update-enum "server_netmask" (woo-list "/openvpn-server/avail_masks"))
	(form-update-enum "vpnnetmask" (woo-list "/openvpn-server/avail_masks"))
	(form-update-value-list
	  '("enabled" "type" "port" "server_net" "server_netmask" "vpnnet" "vpnnetmask"
		"server_vpnaddr" "vpnpool_start" "vpnpool_end")
	  cmd)
	(update-interface)))

(define (write-config reason)
  (catch/message
	(lambda()
	  (apply woo-write
			 "/openvpn-server"
			 'operation reason
			 'type "routed"
			 (form-value-list
			   '("enabled" "port" "server_net" "server_netmask" "vpnnet" "vpnnetmask"
				 "server_vpnaddr" "vpnpool_start" "vpnpool_end"))))))

(define (apply-config)
  (write-config "apply"))

(define (reset-config)
  (write-config "reset"))

(define (create-req)
  (write-config "create-req"))

(define (clients-networks-interface)
  (write-config "config")
  (form-replace "/openvpn-server/clients"))

(define (init)
  (read-config)
  (form-bind "type" "change" read-config)
  (form-bind "clients_managment" "click" clients-networks-interface)
  (form-bind "create_req" "click" create-req)
  (form-bind "reset" "click" reset-config)
  (form-bind "apply" "click" apply-config))

